Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.

Bug 1900181

Summary: Review Request: python-datrie - Efficiently stored Trie Data Structure for Python (uses libdatrie)
Product: [Fedora] Fedora Reporter: Aniket Pradhan <aniketpradhan1999>
Component: Package ReviewAssignee: Andy Mender <andymenderunix>
Status: CLOSED ERRATA QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: unspecified Docs Contact:
Priority: unspecified    
Version: rawhideCC: admiller, andymenderunix, leamas.alec, ngompa13, package-review, pingou, sochotni
Target Milestone: ---Flags: andymenderunix: fedora-review+
Target Release: ---   
Hardware: Unspecified   
OS: Unspecified   
Whiteboard:
Fixed In Version: Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2020-12-03 01:41:38 UTC Type: Bug
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Embargoed:
Bug Depends On:    
Bug Blocks: 1276941    

Description Aniket Pradhan 2020-11-21 08:26:15 UTC
Upstream: https://github.com/pytries/datrie

Spec URL: https://major.fedorapeople.org/python-datrie/python-datrie.spec
SRPM URL: https://major.fedorapeople.org/python-datrie/python-datrie-0.8.2-1.fc33.src.rpm

Koji Scratch Build: https://koji.fedoraproject.org/koji/taskinfo?taskID=55996066

I had to add in a small patch since the string decoding inside the module is by default for little-endian machines. Please refer to this [0] ticket for more info.

Package Description: The library implements the Trie data structure. The trie variable is a dict-like object that can have Unicode keys of certain ranges and Python objects as values.

In addition to implementing the mapping interface, the library tries to facilitate finding the items for a given prefix, and vice versa, finding the items whose keys are prefixes of a given string. As a common special case, finding the longest-prefix item is also supported.

Comment 1 Andy Mender 2020-11-22 15:44:34 UTC
> %global _description %{expand:
> The library implements the Trie data structure. The trie variable is a
> dict-like object that can have Unicode keys of certain ranges and Python
> objects as values.
> 
> In addition to implementing the mapping interface, the library tries to
> facilitate finding the items for a given prefix, and vice versa, finding the
> items whose keys are prefixes of a given string. As a common special case,
> finding the longest-prefix item is also supported.}

Some of the lines are a little too long and rpmlint complains:
python3-datrie.x86_64: E: description-line-too-long C trie variable is a dict-like object that can have unicode keys of certain ranges and Python objects as values.
python3-datrie.x86_64: E: description-line-too-long C In addition to implementing the mapping interface, tries facilitate finding the items for a given prefix, and vice
python3-datrie.x86_64: E: description-line-too-long C versa, finding the items whose keys are prefixes of a given string. As a common special case, finding the

> I had to add in a small patch since the string decoding inside the module is by default for little-endian machines. Please refer to this [0] ticket for more info.

> # Patch to correctly decode on big/little endian systems
> Patch0:			0001-BUG-Decode-string-based-on-byteorder-of-system.patch

If there is an open ticket somewhere, could you add it in a comment above the Patch0 line as well?

Otherwise looks good. Approved! Full review below:
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
     Review: Internal to the package. No problem.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
     Note: Using prebuilt packages
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "*No copyright* GNU Lesser General
     Public License", "GNU Lesser General Public License (v2.1 or later)".
     19 files have unknown license. Detailed output of licensecheck in
     /data/rpmbuild/SPECS/python-datrie/python-datrie/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[ ]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python3-datrie
     Review: Looks bogus.
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.


Rpmlint
-------
Checking: python3-datrie-0.8.2-1.fc34.x86_64.rpm
          python-datrie-debugsource-0.8.2-1.fc34.x86_64.rpm
          python-datrie-0.8.2-1.fc33.src.rpm
python3-datrie.x86_64: W: spelling-error %description -l en_US trie -> tire, true, tie
python3-datrie.x86_64: W: spelling-error %description -l en_US unicode -> Unicode, uni code, uni-code
python3-datrie.x86_64: W: spelling-error %description -l en_US versa -> avers, verse, verso
python3-datrie.x86_64: E: description-line-too-long C trie variable is a dict-like object that can have unicode keys of certain ranges and Python objects as values.
python3-datrie.x86_64: E: description-line-too-long C In addition to implementing the mapping interface, tries facilitate finding the items for a given prefix, and vice
python3-datrie.x86_64: E: description-line-too-long C versa, finding the items whose keys are prefixes of a given string. As a common special case, finding the
python-datrie.src: W: spelling-error %description -l en_US trie -> tire, true, tie
python-datrie.src: W: spelling-error %description -l en_US versa -> avers, verse, verso
python-datrie.src:24: W: mixed-use-of-spaces-and-tabs (spaces: line 15, tab: line 24)
3 packages and 0 specfiles checked; 3 errors, 6 warnings.




Rpmlint (installed packages)
----------------------------
(none): E: no installed packages by name python3-datrie
(none): E: no installed packages by name python-datrie-debugsource
0 packages and 0 specfiles checked; 0 errors, 0 warnings.



Unversioned so-files
--------------------
python3-datrie: /usr/lib64/python3.9/site-packages/datrie.cpython-39-x86_64-linux-gnu.so

Source checksums
----------------
https://files.pythonhosted.org/packages/source/d/datrie/datrie-0.8.2.tar.gz :
  CHECKSUM(SHA256) this package     : 525b08f638d5cf6115df6ccd818e5a01298cd230b2dac91c8ff2e6499d18765d
  CHECKSUM(SHA256) upstream package : 525b08f638d5cf6115df6ccd818e5a01298cd230b2dac91c8ff2e6499d18765d


Requires
--------
python3-datrie (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    python(abi)
    rtld(GNU_HASH)

python-datrie-debugsource (rpmlib, GLIBC filtered):



Provides
--------
python3-datrie:
    python-datrie
    python3-datrie
    python3-datrie(x86-64)
    python3.9-datrie
    python3.9dist(datrie)
    python3dist(datrie)

python-datrie-debugsource:
    python-datrie-debugsource
    python-datrie-debugsource(x86-64)

Comment 2 Aniket Pradhan 2020-11-22 15:52:04 UTC
> Some of the lines are a little too long and rpmlint complains:
> python3-datrie.x86_64: E: description-line-too-long C trie variable is a
> dict-like object that can have unicode keys of certain ranges and Python
> objects as values.
> python3-datrie.x86_64: E: description-line-too-long C In addition to
> implementing the mapping interface, tries facilitate finding the items for a
> given prefix, and vice
> python3-datrie.x86_64: E: description-line-too-long C versa, finding the
> items whose keys are prefixes of a given string. As a common special case,
> finding the

Sure. I'll limit it to 80 characters.

> > I had to add in a small patch since the string decoding inside the module is by default for little-endian machines. Please refer to this [0] ticket for more info.
> 
> > # Patch to correctly decode on big/little endian systems
> > Patch0:			0001-BUG-Decode-string-based-on-byteorder-of-system.patch
> 
> If there is an open ticket somewhere, could you add it in a comment above
> the Patch0 line as well?

Will add that too ^.^

> Otherwise looks good. Approved! Full review below:

Thanks for your review!

Comment 3 Gwyn Ciesla 2020-11-23 14:20:45 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/python-datrie

Comment 4 Fedora Update System 2020-11-24 18:07:56 UTC
FEDORA-2020-7d2e071a35 has been submitted as an update to Fedora 33. https://bodhi.fedoraproject.org/updates/FEDORA-2020-7d2e071a35

Comment 5 Fedora Update System 2020-11-24 18:07:57 UTC
FEDORA-2020-f828007430 has been submitted as an update to Fedora 32. https://bodhi.fedoraproject.org/updates/FEDORA-2020-f828007430

Comment 6 Fedora Update System 2020-11-25 01:19:48 UTC
FEDORA-2020-f828007430 has been pushed to the Fedora 32 testing repository.
In short time you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2020-f828007430 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-f828007430

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 7 Fedora Update System 2020-11-25 02:12:15 UTC
FEDORA-2020-7d2e071a35 has been pushed to the Fedora 33 testing repository.
In short time you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2020-7d2e071a35 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-7d2e071a35

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 8 Fedora Update System 2020-12-03 01:41:38 UTC
FEDORA-2020-f828007430 has been pushed to the Fedora 32 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 9 Fedora Update System 2020-12-04 19:51:43 UTC
FEDORA-2020-7d2e071a35 has been pushed to the Fedora 33 stable repository.
If problem still persists, please make note of it in this bug report.